<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="GENERATOR" content="Mozilla/4.7 [en] (X11; I; Linux 2.2.10 i686) [Netscape]">
   <title>JFLA 2000</title>
</head>
<body bgcolor="#FFFFFF">

<center>
<h1>
JFLA 2000: relecture du papier 7</h1></center>
Numero du papier: 7
<p>Titre du papier: Interaction between Dynamics and the Uniqueness typing
system
<p>Auteurs: Pierre-Fran\c{c}ois Dutot
<p>Nom du rapporteur: Maria-Virginia Aponte
<p>Confiance en la note: 2
<p>Notation du papier:1
<p>Commentaires aux auteurs:
<br>&nbsp;
<br>&nbsp;
<p>1. Clarte de l'article:
<p>a. Il manque pas mal de definitions importantes pour la comprehension:
<p>p. 1 : le langage des types, la difference entre -> et |>
<p>p. 4 : qu'est-ce qu'une position "propagating" pour un type?
<p>p. 5 : Qu'est-ce qu'un "Non-unique Variant type"? (intuitivement?)
<p>p.7 : Quel est le sens (intuitif) de sigma ~ tau? A quoi sert cette
relation?
<p>p.13 : Qu'est-ce que l'algorithme de resolution dynamique de coercion
de types?
<p>b. Le tout premier systeme de typage est-il vraiement necessaire? Il
est a` la base du travail de Barendsen et al., mais n'est pas utilise directement
dans le travail developpe. Le presenter alourdit et obscurcit l'expose.
Pourquoi ne pas presenter directement le typage avec unicite, mais de maniere
plus graduelle?
<p>c. Je n'eai pas trouve ou` la notation 2 (p.5) est employee.
<p>d. La discussion sur la partialite est difficile a comprendre (p.4)
<p>e. Comptage de references: Les explications p.9 (section 5) ne sont
pas claires. Quel est le sens de * ici? Quelle est la coercion (qui n'est
pas possible) et dont on parle a` la fin de la page 9 (type coercions)
et au debut de la page 10?
<p>2. Correction des resultats
<p>a. Que peut-on dire quant aux resultats theoriques pour les deux systemes
fondateurs?
<p>b. Que peut-on dire sur la correction du typage, sa surete vis-a vis
de l'evaluation dans le cas des modifications developpes par l'auteur?
<p>c. Que peut-on dire sur l'unification? d. Pourquoi l'algorithme (qui
n'est pas presente, meme pas vaguement explique) de resolution de coercions
de types (p.13) est-il correcte? Quels sont ses incidences sur la surete
du typage?
<p>Commentaires reserves au comite de programme:
<br>&nbsp;
<br>&nbsp;
<p><u>a. Resume commente:</u>
<p><u>Le contexte:</u>
<p>Le travail s'inscrit dans le projet d'implantation du langage fonctionnel
et concurrent CLEAN, de l'universite de Nijmegen (Pays Bas). Il a ete realise
pendant une visite de l'auteur dans ce laboratoire, visite qui a dure 10
mois.
<p>Ce langage a la particularite de distinguer par le typage (statique)
les expressions qui produisent des effets, de celles qui ne le font pas
(i.e. celles pour lesquelles la propriete de "referential transparency"
est verifiee, p.r aux autres).
<p>Un mecanisme de comptage d'utilisations d'objets est employe. Il y a
les objets qui sont employes 1 fois puis les autres. Les operations destructives
sont alors limitees aux objets dont le compteur de references est 1. Le
comptage des variables est realise par un algorithme de parcours des graphes
(avec partage) des expressions. Ensuite, un systemes de regles de typage
"uniqueness" (d'unicite) est employe pour propager cette information sur
la totalite des expressions. Un attribut d'unicite decore les expressions:
* pour (unicite) et x (pas de restriction d'unicite). Les operations destructives
demandent que leur argument soit decore par *. Des regles de "sous-typage"
permettent de voir un objet avec unicite comme n'ayant pas de restrictions
d'unicite. Le systeme prevoit le traitement du polymorphisme a` la ML et
un algorithme d'unification pour types avec unicite. On montre des resultats
de correction et surete du typage, de "subject reduction", et d'existence
de typage principal. Source: "Uniqueness Typing for Functional Languages
with Graph Rewriting Semantics", Barendsen and Smeters (1996) (Voir dans
la biblio).
<p>Par ailleurs, le travail de Marco Pil donne un cadre de definition pour
la persistance dans le contexte des langages fonctionneles purs et paresseux.
Une definition de dynamiques de premiere classe a ete developpee, (voir
biblio).
<p><u>Le contenu de l'article</u>
<p>Le but de l'article est d'etudier l'integration des deux formalismes
precedents et de fournir les modifications necessaires aux deux systemes
pour etre capable de fabriquer et d'utiliser des dynamiques qui tiennent
compte des informations d'unicite dans les types enfermes. Ce travail semble
devoir etre implante prochainement dans le compilateur de Clean.
<p>La moitie de l'article est dediee a` la description des deux systemes
cites plus haut.
<p>Par la suite, l'auteur presente ses idees pour melanger les dynamiques
et les informations de comptage de references aux objets. La description
est assez brouillone, les exemples donnes ne sont pas facilement comprehensibles:
ils sont ecrits en Clean annote d'attributs d'unicite, or ni la syntaxe
du langage ni celle des annotations n'ont ete donnees.
<p>L'auteur developpe des modifications sur les regles d'inference des
types avec unicite, sur les regles de sous-typage (1er travail cite) et
sur regles d'equivalence entre types (2eme travail cite). Hormis des regles
(deduction naturelle) cette notion d'equivalance n'a jamais ete definie
ni formellement, ni intuitivement. Il s'agit certainement de ce que l'auteur
appele "algorithme d'unfication" dans l'introduction. Suivent des regles
de typage pour toutes les constructions pour manipuler les dynamiques.
La derniere regle introduite concerne la construction d'internalisation
d'un dynamique (open). Il est dit que dans cette construction l'utilisateur
pourra specifier la coercion souhaitee pour l'objet vers un type unique
ou pas. Cela implique la resolution d'une inequation de sous-typage (l'inequation
est une hypothese de la regle) pour tester si la coercion est possible.
L'auteur mentionne un algorithme de resolution de cette inequation dont
il ne donne aucun detail. De plus, la syntaxe pour exprimer de telles coercions
dans le langage n'a jamais ete donnee.
<p>Aucun resultat theorique ne vient etayer le travail. On s'attendrait
au moins a` des resultats de typage principal, et de correction du typage
vis-a-vis de l'evaluation, ainsi que d'une discussion sur les difficultes
eventuelles de "l'algorithme d'unification" avec les types decores.
<p><u>La forme:</u>
<p>L'article est assez difficile a` lire. Il n'est pas bien structure,
il donne l'impression d'un brouillon, l'anglais laisse a` desirer. Les
descriptions des deux formalismes fondateurs sont lacunaires
<p>(il manque des definitions importantes qui sont utilisees dans les regles)
et tres peu claires. Ce n'est pas le cas d'au moins l'une des sources citees,
que ce rapporteur a pu parcourir rapidement.
<p>Enfin l'exposition des idees liees directement au travail de l'auteur
n'est pas plus claire. Il manque notamment des exemples comprehensibles
et quelques eclaircisements sur la syntaxe de Clean.
<p><u>b.Conclusion:</u>
<p>Le projet Clean dans son ensemble semble interessant: le systeme de
types avec unicite parait un compromis interessant de typage "lineaire"
(avec des liens avec la logique lineaire) pour un langage fonctionnel d'utilisation
assez classique. L'idee d'y ajouter des dynamiques qui tiennent compte
de ce typage va dans le sens d'en ettoffer les fontionnalites du langage.
Le theme semble a` priori interessant et la complexite des systemes de
typage promettent qu'il ait de la matiere.
<p>Cependant le travail ne semble pas finalise. Un tel article ne peut
etre accepte, a` mon avis, que si l'auteur fait un important remaniement
de deux points de vue: la clarte de son expose et la correction de son
syteme. Il devrait donc fournir a` defaut de resultats theoriques, au moins
des arguments convaicants qui nous font croire dans la correction de son
systeme. Cependant, le manque de clarte dans l'etat actuel de l'article
ne me font pas trop pencher dans le sens d'une acceptation "conditionnelle".
Ma recommendation est donc de le rejeter.
<p>Il reste que je ne suis pas du tout experte dans le domaine, et par
consequent, j'ai donc du mal a` juger des "chances" pour que le developpement
expose soit correct. Peut-etre que la correction s'en suit trivialement
a` partir des resultats fondateurs. Dans ce cas la, il me semble que l'auteur
devrait au moins l'argumenter.
</body>
</html>
